Package com.microsoft.sqlserver.jdbc

## Interface ISQLServerDataSource

All Superinterfaces:
  `CommonDataSource`

All Known Implementing Classes:
  `SQLServerConnectionPoolDataSource`, `SQLServerDataSource`, `SQLServerXADataSource`

    public interface ISQLServerDataSource
    extends CommonDataSource

A factory to create connections to the data source represented by this object. This interface was added in SQL Server JDBC Driver 3.0. This interface is implemented by `SQLServerDataSource` Class.

### Method Summary

All Methods Instance Methods Abstract Methods
`String` `getAccessToken()` Retrieves the access token.
`String` `getApplicationIntent()` Returns the application intent.
`String` `getApplicationName()` Returns the application name.
`String` `getAuthentication()` Retrieves the authentication mode
`int` `getCancelQueryTimeout()` Getting the cancel timeout
`String` `getColumnEncryptionSetting()` Retrieves the Always Encrypted functionality setting for the data source object.
`String` `getDatabaseName()` Returns the database name.
`String` `getDescription()` Returns a description of the data source.
`boolean` `getDisableStatementPooling()` Determine whether statement pooling is disabled.
`boolean` `getEnablePrepareOnFirstPreparedStatementCall()` If this configuration returns false the first execution of a prepared statement will call sp_executesql and not prepare a statement, once the second execution happens it will call sp_prepexec and actually setup a prepared statement handle.
`boolean` `getEncrypt()` Returns a Boolean value that indicates if the encrypt property is enabled.
`String` `getFailoverPartner()` Returns the name of the failover server that is used in a database mirroring configuration.
`boolean` `getFIPS()` Retrieves value of connection property "fips" For FIPS enabled JVM this property should be true.
`GSSCredential` `getGSSCredentials()` Retrieves the GSSCredential
`String` `getHostNameInCertificate()` Returns the host name used in validating the SQL Server Secure Sockets Layer (SSL) certificate.
`String` `getInstanceName()` Returns the SQL Server instance name.
`String` `getJASSConfigurationName()` Retrieves the login configuration file for Kerberos authentication.
`String` `getKeyStoreAuthentication()` Gets the value of the keyStoreAuthentication setting for the data source object.
`String` `getKeyStoreLocation()` Retrieves the keyStoreLocation for the Java Key Store.
`boolean` `getLastUpdateCount()` Returns a Boolean value that indicates if the lastUpdateCount property is enabled.
`int` `getLockTimeout()` Returns an int value that indicates the number of milliseconds that the database will wait before reporting a lock time out.
`boolean` `getMultiSubnetFailover()` Returns the value of the multiSubnetFailover connection property.
`int` `getPacketSize()` Returns the current network packet size used to communicate with SQL Server, specified in bytes.
`int` `getPortNumber()` Returns the current port number that is used to communicate with SQL Server.
`int` `getQueryTimeout()` Getting the query timeout
`String` `getResponseBuffering()` Returns the response buffering mode for this SQLServerDataSource object.
`String` `getSelectMethod()` Returns the default cursor type used for all result sets that are created by using this SQLServerDataSource object.
`boolean` `getSendStringParametersAsUnicode()` Returns a boolean value that indicates if sending string parameters to the server in UNICODE format is enabled.
`boolean` `getSendTimeAsDatetime()` This method was added in SQL Server JDBC Driver 3.0.
`String` `getServerName()` Returns the name of the SQL Server instance.
`boolean` `getServerNameAsACE()` Retrieves if the serverName should be translated from Unicode to ASCII Compatible Encoding (ACE)
`int` `getServerPreparedStatementDiscardThreshold()` This setting controls how many outstanding prepared statement discard actions (sp_unprepare) can be outstanding per connection before a call to clean-up the outstanding handles on the server is executed.
`String` `getServerSpn()` Returns the server spn
`int` `getSocketTimeout()` Getting the socket timeout
`String` `getSSLProtocol()` Retrieves value of connection property 'sslProtocol'
`int` `getStatementPoolingCacheSize()` Returns the size of the prepared statement cache for this connection.
`boolean` `getTransparentNetworkIPResolution()` Retrieves the TransparentNetworkIPResolution value.
`String` `getTrustManagerClass()` Retrieves value for the connection property 'trustManagerClass'
`String` `getTrustManagerConstructorArg()` Retrieves value for the connection property 'trustManagerConstructorArg'
`boolean` `getTrustServerCertificate()` Returns a Boolean value that indicates if the trustServerCertificate property is enabled.
`String` `getTrustStore()` Returns the path (including file name) to the certificate trustStore file.
`String` `getTrustStoreType()` Returns the keyStore Type for the trustStore
`String` `getURL()` Returns the URL that is used to connect to the data source.
`boolean` `getUseBulkCopyForBatchInsert()` Getting the use Bulk Copy API for Batch Insert
`String` `getUser()` Returns the user name that is used to connect the data source.
`String` `getWorkstationID()` Returns the name of the client computer name that is used to connect to the data source.
`boolean` `getXopenStates()` Returns a boolean value that indicates if converting SQL states to XOPEN compliant states is enabled.
`void` `setAccessToken​(String accessToken)` Sets the access token.
`void` `setApplicationIntent​(String applicationIntent)` Sets the application intent.
`void` `setApplicationName​(String applicationName)` Sets the application name.
`void` `setAuthentication​(String authentication)` sets the authentication mode
`void` `setAuthenticationScheme​(String authenticationScheme)` Indicates the kind of integrated security you want your application to use.
`void` `setCancelQueryTimeout​(int cancelQueryTimeout)` Setting the cancel timeout
`void` `setColumnEncryptionSetting​(String columnEncryptionSetting)` Enables/disables Always Encrypted functionality for the data source object.
`void` `setDatabaseName​(String databaseName)` Sets the database name to connect to.
`void` `setDescription​(String description)` Sets the description of the data source.
`void` `setDisableStatementPooling​(boolean disableStatementPooling)` Disable/enable statement pooling.
`void` `setEnablePrepareOnFirstPreparedStatementCall​(boolean enablePrepareOnFirstPreparedStatementCall)` If this configuration is false the first execution of a prepared statement will call sp_executesql and not prepare a statement, once the second execution happens it will call sp_prepexec and actually setup a prepared statement handle.
`void` `setEncrypt​(boolean encrypt)` Sets a Boolean value that indicates if the encrypt property is enabled.
`void` `setFailoverPartner​(String serverName)` Sets the name of the failover server that is used in a database mirroring configuration.
`void` `setFIPS​(boolean fips)` Enables Fips Mode on the connection For FIPS enabled JVM this property should be true.
`void` `setGSSCredentials​(GSSCredential userCredential)` sets GSSCredential
`void` `setHostNameInCertificate​(String hostName)` Sets the host name to be used in validating the SQL Server Secure Sockets Layer (SSL) certificate.
`void` `setInstanceName​(String instanceName)` Sets the SQL Server instance name.
`void` `setIntegratedSecurity​(boolean enable)` Sets a Boolean value that indicates if the integratedSecurity property is enabled.
`void` `setJASSConfigurationName​(String configurationName)` Sets the login configuration file for Kerberos authentication.
`void` `setKeyStoreAuthentication​(String keyStoreAuthentication)` Sets the name that identifies a key store.
`void` `setKeyStoreLocation​(String keyStoreLocation)` Sets the location including the file name for the Java keystore.
`void` `setKeyStoreSecret​(String keyStoreSecret)` Sets the password for the Java keystore.
`void` `setLastUpdateCount​(boolean lastUpdateCount)` Sets a Boolean value that indicates if the lastUpdateCount property is enabled.
`void` `setLockTimeout​(int lockTimeout)` Sets an int value that indicates the number of milliseconds to wait before the database reports a lock time out.
`void` `setMultiSubnetFailover​(boolean multiSubnetFailover)` Sets the value of the multiSubnetFailover connection property.
`void` `setPacketSize​(int packetSize)` Sets the current network packet size used to communicate with SQL Server, specified in bytes.
`void` `setPassword​(String password)` Sets the password that will be used to connect to SQL Server.
`void` `setPortNumber​(int portNumber)` Sets the port number to be used to communicate with SQL Server.
`void` `setQueryTimeout​(int queryTimeout)` Setting the query timeout
`void` `setResponseBuffering​(String bufferingMode)` Sets the response buffering mode for connections created by using this SQLServerDataSource object.
`void` `setSelectMethod​(String selectMethod)` Sets the default cursor type that is used for all result sets that are created by using this SQLServerDataSource object.
`void` `setSendStringParametersAsUnicode​(boolean sendStringParametersAsUnicode)` Sets a boolean value that indicates if sending string parameters to the server in UNICODE format is enabled.
`void` `setSendTimeAsDatetime​(boolean sendTimeAsDatetime)` Modifies the setting of the sendTimeAsDatetime connection property.
`void` `setServerName​(String serverName)` Sets the name of the computer that is running SQL Server.
`void` `setServerNameAsACE​(boolean serverNameAsACE)` Translates the serverName from Unicode to ASCII Compatible Encoding (ACE)
`void` `setServerPreparedStatementDiscardThreshold​(int serverPreparedStatementDiscardThreshold)` This setting controls how many outstanding prepared statement discard actions (sp_unprepare) can be outstanding per connection before a call to clean-up the outstanding handles on the server is executed.
`void` `setServerSpn​(String serverSpn)` Sets the server spn
`void` `setSocketTimeout​(int socketTimeout)` Setting the socket timeout
`void` `setSSLProtocol​(String sslProtocol)` Sets the sslProtocol property for connection Set this value to specify TLS protocol keyword.
`void` `setStatementPoolingCacheSize​(int statementPoolingCacheSize)` Specifies the size of the prepared statement cache for this connection.
`void` `setTransparentNetworkIPResolution​(boolean tnir)` Beginning in version 6.0 of the Microsoft JDBC Driver for SQL Server, a new connection property transparentNetworkIPResolution (TNIR) is added for transparent connection to Always On availability groups or to a server which has multiple IP addresses associated.
`void` `setTrustManagerClass​(String trustManagerClass)` Sets the connection property 'trustManagerClass' on the connection
`void` `setTrustManagerConstructorArg​(String trustManagerConstructorArg)` Sets Constructor Arguments to be provided on constructor of 'trustManagerClass'
`void` `setTrustServerCertificate​(boolean e)` Sets a Boolean value that indicates if the trustServerCertificate property is enabled.
`void` `setTrustStore​(String trustStore)` Sets the path (including file name) to the certificate trustStore file.
`void` `setTrustStorePassword​(String trustStorePassword)` Sets the password that is used to check the integrity of the trustStore data.
`void` `setTrustStoreType​(String trustStoreType)` This parameter defines the keystore type for the trustStore.
`void` `setURL​(String url)` Sets the URL that is used to connect to the data source.
`void` `setUseBulkCopyForBatchInsert​(boolean useBulkCopyForBatchInsert)` Setting the use Bulk Copy API for Batch Insert
`void` `setUser​(String user)` Sets the user name that is used to connect the data source.
`void` `setWorkstationID​(String workstationID)` Sets the name of the client computer name that is used to connect to the data source.
`void` `setXopenStates​(boolean xopenStates)` Sets a Boolean value that indicates if converting SQL states to XOPEN compliant states is enabled.

### Methods inherited from interface javax.sql.CommonDataSource

`createShardingKeyBuilder, getLoginTimeout, getLogWriter, getParentLogger, setLoginTimeout, setLogWriter`

### Method Detail

#### setApplicationIntent

    void setApplicationIntent​(String applicationIntent)

Sets the application intent.

Parameters:
  `applicationIntent` - A String that contains the application intent.

#### getApplicationIntent

    String getApplicationIntent()

Returns the application intent.

Returns:
  A String that contains the application intent.

#### setApplicationName

    void setApplicationName​(String applicationName)

Sets the application name.

Parameters:
  `applicationName` - A String that contains the name of the application.

#### getApplicationName

    String getApplicationName()

Returns the application name.

Returns:
  A String that contains the application name, or "Microsoft JDBC Driver for SQL Server" if no value is set.

#### setDatabaseName

    void setDatabaseName​(String databaseName)

Sets the database name to connect to.

Parameters:
  `databaseName` - A String that contains the database name.

#### getDatabaseName

    String getDatabaseName()

Returns the database name.

Returns:
  A String that contains the database name or null if no value is set.

#### setInstanceName

    void setInstanceName​(String instanceName)

Sets the SQL Server instance name.

Parameters:
  `instanceName` - A String that contains the instance name.

#### getInstanceName

    String getInstanceName()

Returns the SQL Server instance name.

Returns:
  A String that contains the instance name, or null if no value is set.

#### setIntegratedSecurity

    void setIntegratedSecurity​(boolean enable)

Sets a Boolean value that indicates if the integratedSecurity property is enabled.

Parameters:
  `enable` - true if integratedSecurity is enabled. Otherwise, false.

#### setLastUpdateCount

    void setLastUpdateCount​(boolean lastUpdateCount)

Sets a Boolean value that indicates if the lastUpdateCount property is enabled.

Parameters:
  `lastUpdateCount` - true if lastUpdateCount is enabled. Otherwise, false.

#### getLastUpdateCount

    boolean getLastUpdateCount()

Returns a Boolean value that indicates if the lastUpdateCount property is enabled.

Returns:
  true if lastUpdateCount is enabled. Otherwise, false.

#### setEncrypt

    void setEncrypt​(boolean encrypt)

Sets a Boolean value that indicates if the encrypt property is enabled.

Parameters:
  `encrypt` - true if the Secure Sockets Layer (SSL) encryption is enabled between the client and the SQL Server. Otherwise, false.

#### getEncrypt

    boolean getEncrypt()

Returns a Boolean value that indicates if the encrypt property is enabled.

Returns:
  true if encrypt is enabled. Otherwise, false.

#### setTransparentNetworkIPResolution

    void setTransparentNetworkIPResolution​(boolean tnir)

Beginning in version 6.0 of the Microsoft JDBC Driver for SQL Server, a new connection property transparentNetworkIPResolution (TNIR) is added for transparent connection to Always On availability groups or to a server which has multiple IP addresses associated. When transparentNetworkIPResolution is true, the driver attempts to connect to the first IP address available. If the first attempt fails, the driver tries to connect to all IP addresses in parallel until the timeout expires, discarding any pending connection attempts when one of them succeeds.

transparentNetworkIPResolution is ignored if multiSubnetFailover is true

transparentNetworkIPResolution is ignored if database mirroring is used

transparentNetworkIPResolution is ignored if there are more than 64 IP addresses

Parameters:
  `tnir` - if set to true, the driver attempts to connect to the first IP address available. It is true by default.

#### getTransparentNetworkIPResolution

    boolean getTransparentNetworkIPResolution()

Retrieves the TransparentNetworkIPResolution value.

Returns:
  if enabled, returns true. Otherwise, false.

#### setTrustServerCertificate

    void setTrustServerCertificate​(boolean e)

Sets a Boolean value that indicates if the trustServerCertificate property is enabled.

Parameters:
  `e` - true, if the server Secure Sockets Layer (SSL) certificate should be automatically trusted when the communication layer is encrypted using SSL. Otherwise, false.

#### getTrustServerCertificate

    boolean getTrustServerCertificate()

Returns a Boolean value that indicates if the trustServerCertificate property is enabled.

Returns:
  true if trustServerCertificate is enabled. Otherwise, false.

#### setTrustStoreType

    void setTrustStoreType​(String trustStoreType)

This parameter defines the keystore type for the trustStore.

Parameters:
  `trustStoreType` - A String that contains the trust store type

#### getTrustStoreType

    String getTrustStoreType()

Returns the keyStore Type for the trustStore

Returns:
  trustStoreType A String that contains the trust store type

#### setTrustStore

    void setTrustStore​(String trustStore)

Sets the path (including file name) to the certificate trustStore file.

Parameters:
  `trustStore` - A String that contains the path (including file name) to the certificate trustStore file.

#### getTrustStore

    String getTrustStore()

Returns the path (including file name) to the certificate trustStore file.

Returns:
  trustStore A String that contains the path (including file name) to the certificate trustStore file, or null if no value is set.

#### setTrustStorePassword

    void setTrustStorePassword​(String trustStorePassword)

Sets the password that is used to check the integrity of the trustStore data.

Parameters:
  `trustStorePassword` - A String that contains the password that is used to check the integrity of the trustStore data.

#### setHostNameInCertificate

    void setHostNameInCertificate​(String hostName)

Sets the host name to be used in validating the SQL Server Secure Sockets Layer (SSL) certificate.

Parameters:
  `hostName` - A String that contains the host name.

#### getHostNameInCertificate

    String getHostNameInCertificate()

Returns the host name used in validating the SQL Server Secure Sockets Layer (SSL) certificate.

Returns:
  A String that contains the host name, or null if no value is set.

#### setLockTimeout

    void setLockTimeout​(int lockTimeout)

Sets an int value that indicates the number of milliseconds to wait before the database reports a lock time out.

Parameters:
  `lockTimeout` - An int value that contains the number of milliseconds to wait.

#### getLockTimeout

    int getLockTimeout()

Returns an int value that indicates the number of milliseconds that the database will wait before reporting a lock time out.

Returns:
  An int value that contains the number of milliseconds that the database will wait.

#### setPassword

    void setPassword​(String password)

Sets the password that will be used to connect to SQL Server.

Parameters:
  `password` - A String that contains the password.

#### setPortNumber

    void setPortNumber​(int portNumber)

Sets the port number to be used to communicate with SQL Server.

Parameters:
  `portNumber` - An int value that contains the port number.

#### getPortNumber

    int getPortNumber()

Returns the current port number that is used to communicate with SQL Server.

Returns:
  An int value that contains the current port number.

#### setSelectMethod

    void setSelectMethod​(String selectMethod)

Sets the default cursor type that is used for all result sets that are created by using this SQLServerDataSource object.

Parameters:
  `selectMethod` - A String value that contains the default cursor type.

#### getSelectMethod

    String getSelectMethod()

Returns the default cursor type used for all result sets that are created by using this SQLServerDataSource object.

Returns:
  A String value that contains the default cursor type.

#### setResponseBuffering

    void setResponseBuffering​(String bufferingMode)

Sets the response buffering mode for connections created by using this SQLServerDataSource object.

Parameters:
  `bufferingMode` - A String that contains the buffering and streaming mode. The valid mode can be one of the following case-insensitive Strings: full or adaptive.

#### getResponseBuffering

    String getResponseBuffering()

Returns the response buffering mode for this SQLServerDataSource object.

Returns:
  A String that contains a lower-case full or adaptive.

#### setSendTimeAsDatetime

    void setSendTimeAsDatetime​(boolean sendTimeAsDatetime)

Modifies the setting of the sendTimeAsDatetime connection property.

Parameters:
  `sendTimeAsDatetime` - A Boolean value. When true, causes java.sql.Time values to be sent to the server as SQL Server datetime types. When false, causes java.sql.Time values to be sent to the server as SQL Server time types.

#### getSendTimeAsDatetime

    boolean getSendTimeAsDatetime()

This method was added in SQL Server JDBC Driver 3.0. Returns the setting of the sendTimeAsDatetime connection property.

Returns:
  true if java.sql.Time values will be sent to the server as a SQL Server datetime type. false if java.sql.Time values will be sent to the server as a SQL Server time type.

#### setSendStringParametersAsUnicode

    void setSendStringParametersAsUnicode​(boolean sendStringParametersAsUnicode)

Sets a boolean value that indicates if sending string parameters to the server in UNICODE format is enabled.

Parameters:
  `sendStringParametersAsUnicode` - true if string parameters are sent to the server in UNICODE format. Otherwise, false.

#### getSendStringParametersAsUnicode

    boolean getSendStringParametersAsUnicode()

Returns a boolean value that indicates if sending string parameters to the server in UNICODE format is enabled.

Returns:
  true if string parameters are sent to the server in UNICODE format. Otherwise, false.

#### setServerNameAsACE

    void setServerNameAsACE​(boolean serverNameAsACE)

Translates the serverName from Unicode to ASCII Compatible Encoding (ACE)

Parameters:
  `serverNameAsACE` - if enabled the servername will be translated to ASCII Compatible Encoding (ACE)

#### getServerNameAsACE

    boolean getServerNameAsACE()

Retrieves if the serverName should be translated from Unicode to ASCII Compatible Encoding (ACE)

Returns:
  if enabled, will return true. Otherwise, false.

#### setServerName

    void setServerName​(String serverName)

Sets the name of the computer that is running SQL Server.

Parameters:
  `serverName` - A String that contains the server name.

#### getServerName

    String getServerName()

Returns the name of the SQL Server instance.

Returns:
  A String that contains the server name or null if no value is set.

#### setFailoverPartner

    void setFailoverPartner​(String serverName)

Sets the name of the failover server that is used in a database mirroring configuration.

Parameters:
  `serverName` - A String that contains the failover server name.

#### getFailoverPartner

    String getFailoverPartner()

Returns the name of the failover server that is used in a database mirroring configuration.

Returns:
  A String that contains the name of the failover partner, or null if none is set.

#### setMultiSubnetFailover

    void setMultiSubnetFailover​(boolean multiSubnetFailover)

Sets the value of the multiSubnetFailover connection property.

Parameters:
  `multiSubnetFailover` - The new value of the multiSubnetFailover connection property.

#### getMultiSubnetFailover

    boolean getMultiSubnetFailover()

Returns the value of the multiSubnetFailover connection property.

Returns:
  Returns true or false, depending on the current setting of the connection property.

#### setUser

    void setUser​(String user)

Sets the user name that is used to connect the data source.

Parameters:
  `user` - A String that contains the user name.

#### getUser

    String getUser()

Returns the user name that is used to connect the data source.

Returns:
  A String that contains the user name.

#### setWorkstationID

    void setWorkstationID​(String workstationID)

Sets the name of the client computer name that is used to connect to the data source.

Parameters:
  `workstationID` - A String that contains the client computer name.

#### getWorkstationID

    String getWorkstationID()

Returns the name of the client computer name that is used to connect to the data source.

Returns:
  A String that contains the client computer name.

#### setXopenStates

    void setXopenStates​(boolean xopenStates)

Sets a Boolean value that indicates if converting SQL states to XOPEN compliant states is enabled.

Parameters:
  `xopenStates` - true if converting SQL states to XOPEN compliant states is enabled. Otherwise, false.

#### getXopenStates

    boolean getXopenStates()

Returns a boolean value that indicates if converting SQL states to XOPEN compliant states is enabled.

Returns:
  true if converting SQL states to XOPEN compliant states is enabled. Otherwise, false.

#### setURL

    void setURL​(String url)

Sets the URL that is used to connect to the data source.

Parameters:
  `url` - A String that contains the URL.

#### getURL

    String getURL()

Returns the URL that is used to connect to the data source.

Returns:
  A String that contains the URL.

#### setDescription

    void setDescription​(String description)

Sets the description of the data source.

Parameters:
  `description` - A String that contains the description.

#### getDescription

    String getDescription()

Returns a description of the data source.

Returns:
  A String that contains the data source description or null if no value is set.

#### setPacketSize

    void setPacketSize​(int packetSize)

Sets the current network packet size used to communicate with SQL Server, specified in bytes.

Parameters:
  `packetSize` - An int value containing the network packet size.

#### getPacketSize

    int getPacketSize()

Returns the current network packet size used to communicate with SQL Server, specified in bytes.

Returns:
  An int value containing the current network packet size.

#### setAuthenticationScheme

    void setAuthenticationScheme​(String authenticationScheme)

Indicates the kind of integrated security you want your application to use.

Parameters:
  `authenticationScheme` - Values are "JavaKerberos" and the default "NativeAuthentication".

#### setAuthentication

    void setAuthentication​(String authentication)

sets the authentication mode

Parameters:
  `authentication` - the authentication mode

#### getAuthentication

    String getAuthentication()

Retrieves the authentication mode

Returns:
  the authentication value

#### setServerSpn

    void setServerSpn​(String serverSpn)

Sets the server spn

Parameters:
  `serverSpn` - A String that contains the server spn

#### getServerSpn

    String getServerSpn()

Returns the server spn

Returns:
  A String that contains the server spn

#### setGSSCredentials

    void setGSSCredentials​(GSSCredential userCredential)

sets GSSCredential

Parameters:
  `userCredential` - the credential

#### getGSSCredentials

    GSSCredential getGSSCredentials()

Retrieves the GSSCredential

Returns:
  GSSCredential

#### setAccessToken

    void setAccessToken​(String accessToken)

Sets the access token.

Parameters:
  `accessToken` - to be set in the string property.

#### getAccessToken

    String getAccessToken()

Retrieves the access token.

Returns:
  the access token.

#### setColumnEncryptionSetting

    void setColumnEncryptionSetting​(String columnEncryptionSetting)

Enables/disables Always Encrypted functionality for the data source object. The default is Disabled.

Parameters:
  `columnEncryptionSetting` - Enables/disables Always Encrypted functionality for the data source object. The default is Disabled.

#### getColumnEncryptionSetting

    String getColumnEncryptionSetting()

Retrieves the Always Encrypted functionality setting for the data source object.

Returns:
  the Always Encrypted functionality setting for the data source object.

#### setKeyStoreAuthentication

    void setKeyStoreAuthentication​(String keyStoreAuthentication)

Sets the name that identifies a key store. Only value supported is the "JavaKeyStorePassword" for identifying the Java Key Store. The default is null.

Parameters:
  `keyStoreAuthentication` - the name that identifies a key store.

#### getKeyStoreAuthentication

    String getKeyStoreAuthentication()

Gets the value of the keyStoreAuthentication setting for the data source object.

Returns:
  the value of the keyStoreAuthentication setting for the data source object.

#### setKeyStoreSecret

    void setKeyStoreSecret​(String keyStoreSecret)

Sets the password for the Java keystore. Note that, for Java Key Store provider the password for the keystore and the key must be the same. Note that, keyStoreAuthentication must be set with "JavaKeyStorePassword".

Parameters:
  `keyStoreSecret` - the password to use for the keystore as well as for the key

#### setKeyStoreLocation

    void setKeyStoreLocation​(String keyStoreLocation)

Sets the location including the file name for the Java keystore. Note that, keyStoreAuthentication must be set with "JavaKeyStorePassword".

Parameters:
  `keyStoreLocation` - the location including the file name for the Java keystore.

#### getKeyStoreLocation

    String getKeyStoreLocation()

Retrieves the keyStoreLocation for the Java Key Store.

Returns:
  the keyStoreLocation for the Java Key Store.

#### setQueryTimeout

    void setQueryTimeout​(int queryTimeout)

Setting the query timeout

Parameters:
  `queryTimeout` - The number of seconds to wait before a timeout has occurred on a query. The default value is 0, which means infinite timeout.

#### getQueryTimeout

    int getQueryTimeout()

Getting the query timeout

Returns:
  The number of seconds to wait before a timeout has occurred on a query.

#### setCancelQueryTimeout

    void setCancelQueryTimeout​(int cancelQueryTimeout)

Setting the cancel timeout

Parameters:
  `cancelQueryTimeout` - The number of seconds to wait before we wait for the query timeout to happen.

#### getCancelQueryTimeout

    int getCancelQueryTimeout()

Getting the cancel timeout

Returns:
  the number of seconds to wait before we wait for the query timeout to happen.

#### setEnablePrepareOnFirstPreparedStatementCall

    void setEnablePrepareOnFirstPreparedStatementCall​(boolean enablePrepareOnFirstPreparedStatementCall)

If this configuration is false the first execution of a prepared statement will call sp_executesql and not prepare a statement, once the second execution happens it will call sp_prepexec and actually setup a prepared statement handle. Following executions will call sp_execute. This relieves the need for sp_unprepare on prepared statement close if the statement is only executed once.

Parameters:
  `enablePrepareOnFirstPreparedStatementCall` - Changes the setting per the description.

#### getEnablePrepareOnFirstPreparedStatementCall

    boolean getEnablePrepareOnFirstPreparedStatementCall()

If this configuration returns false the first execution of a prepared statement will call sp_executesql and not prepare a statement, once the second execution happens it will call sp_prepexec and actually setup a prepared statement handle. Following executions will call sp_execute. This relieves the need for sp_unprepare on prepared statement close if the statement is only executed once.

Returns:
  Returns the current setting per the description.

#### setServerPreparedStatementDiscardThreshold

    void setServerPreparedStatementDiscardThreshold​(int serverPreparedStatementDiscardThreshold)

This setting controls how many outstanding prepared statement discard actions (sp_unprepare) can be outstanding per connection before a call to clean-up the outstanding handles on the server is executed. If the setting is <= 1 unprepare actions will be executed immedietely on prepared statement close. If it is set to > 1 these calls will be batched together to avoid overhead of calling sp_unprepare too often.

Parameters:
  `serverPreparedStatementDiscardThreshold` - Changes the setting per the description.

#### getServerPreparedStatementDiscardThreshold

    int getServerPreparedStatementDiscardThreshold()

This setting controls how many outstanding prepared statement discard actions (sp_unprepare) can be outstanding per connection before a call to clean-up the outstanding handles on the server is executed. If the setting is <= 1 unprepare actions will be executed immedietely on prepared statement close. If it is set to > 1 these calls will be batched together to avoid overhead of calling sp_unprepare too often.

Returns:
  Returns the current setting per the description.

#### setStatementPoolingCacheSize

    void setStatementPoolingCacheSize​(int statementPoolingCacheSize)

Specifies the size of the prepared statement cache for this connection. A value less than 1 means no cache.

Parameters:
  `statementPoolingCacheSize` - Changes the setting per the description.

#### getStatementPoolingCacheSize

    int getStatementPoolingCacheSize()

Returns the size of the prepared statement cache for this connection. A value less than 1 means no cache.

Returns:
  Returns the current setting per the description.

#### setDisableStatementPooling

    void setDisableStatementPooling​(boolean disableStatementPooling)

Disable/enable statement pooling.

Parameters:
  `disableStatementPooling` - true to disable statement pooling, false to enable it.

#### getDisableStatementPooling

    boolean getDisableStatementPooling()

Determine whether statement pooling is disabled.

Returns:
  true if statement pooling is disabled, false if it is enabled.

#### setSocketTimeout

    void setSocketTimeout​(int socketTimeout)

Setting the socket timeout

Parameters:
  `socketTimeout` - The number of milliseconds to wait before a timeout is occurred on a socket read or accept. The default value is 0, which means infinite timeout.

#### getSocketTimeout

    int getSocketTimeout()

Getting the socket timeout

Returns:
  The number of milliseconds to wait before a timeout is occurred on a socket read or accept.

#### setJASSConfigurationName

    void setJASSConfigurationName​(String configurationName)

Sets the login configuration file for Kerberos authentication. This overrides the default configuration SQLJDBCDriver

Parameters:
  `configurationName` - the configuration name

#### getJASSConfigurationName

    String getJASSConfigurationName()

Retrieves the login configuration file for Kerberos authentication.

Returns:
  login configuration file name

#### setFIPS

    void setFIPS​(boolean fips)

Enables Fips Mode on the connection For FIPS enabled JVM this property should be true.

Parameters:
  `fips` - Boolean property to enable/disable fips

#### getFIPS

    boolean getFIPS()

Retrieves value of connection property "fips" For FIPS enabled JVM this property should be true.

Returns:
  fips boolean value

#### setSSLProtocol

    void setSSLProtocol​(String sslProtocol)

Sets the sslProtocol property for connection Set this value to specify TLS protocol keyword. Acceptable values are: TLS, TLSv1, TLSv1.1, and TLSv1.2.

Parameters:
  `sslProtocol` - Value for SSL Protocol to be set.

#### getSSLProtocol

    String getSSLProtocol()

Retrieves value of connection property 'sslProtocol'

Returns:
  sslProtocol property value

#### setTrustManagerClass

    void setTrustManagerClass​(String trustManagerClass)

Sets the connection property 'trustManagerClass' on the connection

Parameters:
  `trustManagerClass` - The fully qualified class name of a custom javax.net.ssl.TrustManager.

#### getTrustManagerClass

    String getTrustManagerClass()

Retrieves value for the connection property 'trustManagerClass'

Returns:
  trustManagerClass property value

#### setTrustManagerConstructorArg

    void setTrustManagerConstructorArg​(String trustManagerConstructorArg)

Sets Constructor Arguments to be provided on constructor of 'trustManagerClass'

Parameters:
  `trustManagerConstructorArg` - 'trustManagerClass' constructor arguments

#### getTrustManagerConstructorArg

    String getTrustManagerConstructorArg()

Retrieves value for the connection property 'trustManagerConstructorArg'

Returns:
  trustManagerConstructorArg property value

#### getUseBulkCopyForBatchInsert

    boolean getUseBulkCopyForBatchInsert()

Getting the use Bulk Copy API for Batch Insert

Returns:
  whether the driver should use Bulk Copy API for Batch Insert operations.

#### setUseBulkCopyForBatchInsert

    void setUseBulkCopyForBatchInsert​(boolean useBulkCopyForBatchInsert)

Setting the use Bulk Copy API for Batch Insert

Parameters:
  `useBulkCopyForBatchInsert` - indicates whether Bulk Copy API should be used for Batch Insert operations.